<?xml version="1.0"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/officity/factory/modules/ModuleLink.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:OFFICITY="http://officity.com">
    <xsl:import href="include.xsl"/>
    <xsl:output encoding="UTF-8" method="xml" indent="no"/>
    <xsl:strip-space elements="*"/>

	<!-- parameters -->
    <xsl:param name="module" select="/RESPONSE/URL/module"/>
    <xsl:param name="searchText" select="/RESPONSE/URL/quicksearch-text" />
    <xsl:param name="originID" select="/RESPONSE/URL/originID"/>
    <xsl:param name="dependency" select="/RESPONSE/URL/dependency"/>
    <xsl:param name="targetModule" select="/RESPONSE/URL/targetModule"/>
    <xsl:param name="depsList" select="'depsList'"/>
    
	<xsl:template match="/RESPONSE">
		<xsl:call-template name="panel-link">
			<xsl:with-param name="list" select="/RESPONSE/RESULTS[@name='list']"/>
	        <xsl:with-param name="addNew" select="true()"/>
	        <xsl:with-param name="addNewScript" select="'modules/ModuleNew'" />
	        <xsl:with-param name="pagingStyle" select="'pager'"/>
		</xsl:call-template>
    </xsl:template>
    
	<!-- link list -->
	<xsl:template name="panel-list-link">
		<xsl:param name="list" />
		
        <xsl:choose>
            <xsl:when test="$list/@hits > 0">
                <xsl:for-each select="$list/*">
                	<xsl:sort select="not(DEPENDENCIES/DEPENDENCY[@type='officity:moduleNamespaces']/NAMESPACE)" />
                	<xsl:sort select="DEPENDENCIES/DEPENDENCY[@type='officity:moduleNamespaces']/NAMESPACE/INFO/EDITOR" />
                	<xsl:sort select="not(DESCRIPTIONS/DESCRIPTION/HEADER)" />
                	<xsl:sort select="DESCRIPTIONS/DESCRIPTION/HEADER" />
                	<xsl:sort select="INFO/DENOMINATION" />
                    <xsl:apply-templates select="." mode="element-navitem-link" />
                </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
                <div class="no-result">No hits</div>
            </xsl:otherwise>
        </xsl:choose>
	</xsl:template>	
</xsl:stylesheet>
