<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/officity/factory/modules/displayconfig-resources-cmds.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output encoding="UTF-8" method="xml" indent="no" omit-xml-declaration="yes"/>
	<xsl:strip-space elements="*"/>

	<xsl:template match="/RESPONSE">
		<SEARCH refresh="daily" name="fields-{/RESPONSE/URL/module}">
			<FIELD displayable="1" module="{/RESPONSE/URL/module}"/>
			<RETURN>
				<INFO>
					<MODULE/>
					<DENOMINATION/>
				</INFO>
				<DESCRIPTION>
					<TITLE/>
					<SUMMARY/>
				</DESCRIPTION>
			</RETURN>
		</SEARCH>
		<GET name="{/RESPONSE/URL/module}">
			<MODULE denomination="{/RESPONSE/URL/module}" />
			<RETURN>
				<INFO>
					<DENOMINATION />
				</INFO>
				<DESCRIPTION>
					<HEADER />
				</DESCRIPTION>
			</RETURN>
		</GET>
        <xsl:apply-templates select="RESULTS/DEPENDENCYENTITY/DEPENDENCYTYPE"/>
    </xsl:template>

	<xsl:template match="DEPENDENCYTYPE[
		not(preceding::DEPENDENCYTYPE/@to=@to) and (@to != /RESPONSE/URL/module)
	]">
		<SEARCH refresh="daily" name="fields-{@to}">
			<FIELD displayable="1" module="{@to}"/>
			<RETURN>
				<INFO>
					<MODULE/>
					<DENOMINATION/>
				</INFO>
				<DESCRIPTION>
					<TITLE/>
					<SUMMARY/>
				</DESCRIPTION>
			</RETURN>
		</SEARCH>
		<GET name="{@to}">
			<MODULE denomination="{@to}" />
			<RETURN>
				<INFO>
					<DENOMINATION />
				</INFO>
				<DESCRIPTION>
					<HEADER />
				</DESCRIPTION>
			</RETURN>
		</GET>
	</xsl:template>
	
	<xsl:template match="DEPENDENCYTYPE" />
</xsl:stylesheet>