<?xml version="1.0"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/officity/factory/publishers/Index.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:NECTIL="http://nectil.com">
    <xsl:import href="include.xsl"/>    
    <xsl:output encoding="UTF-8" method="xml" indent="no"/>
    <xsl:strip-space elements="*"/>
    
    <xsl:param name="list" select="/RESPONSE/RESULTS[@name='list']" />

	<xsl:template match="/RESPONSE">
		<xsl:call-template name="panel-results">
			<xsl:with-param name="addNew" select="true()" />
		</xsl:call-template>
	</xsl:template>
	
	<!-- custom results list header -->
	<xsl:template name="panel-list-header-results">
        <xsl:param name="list" />
        <xsl:param name="module" />
        <xsl:param name="addNew" />
        <xsl:param name="addNewScript" />
        
        <xsl:call-template name="nav-new">
            <xsl:with-param name="title">
            	<xsl:choose>
            		<xsl:when test="not(/RESPONSE/URL/namespace) or $list/NECTIL:PUBLISHER[INFO/NAMESPACE=/RESPONSE/URL/namespace]">
            			<xsl:text>Create new...</xsl:text>
           			</xsl:when>
           			<xsl:otherwise>
           				<xsl:text>Create new publisher: </xsl:text>
           				<xsl:value-of select="/RESPONSE/URL/namespace" />
           			</xsl:otherwise>
         		</xsl:choose>
           	</xsl:with-param>
            <xsl:with-param name="module" select="'nectil:publisher'" />
            <xsl:with-param name="panelURI" select="$addNewScript" />
            <xsl:with-param name="cssclass" select="'grey-bkgnd'" />
        </xsl:call-template>
	</xsl:template>
</xsl:stylesheet>