<?xml version="1.0"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/system/tools/security/functions.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:OFFICITY="http://officity.com">
	<xsl:template name="owners-permissions">
		<xsl:param name="element"/>
		<xsl:param name="title" select="'Users'"/>
		<xsl:param name="cssclass"/>
		<xsl:param name="params"/>

		<xsl:call-template name="navigationdetailsitem">
			<xsl:with-param name="title" select="$title"/>
			<xsl:with-param name="panelURI" select="'../../system/tools/security/OwnersPermissions'"/>
			<xsl:with-param name="cssclass" select="$cssclass"/>
			<xsl:with-param name="params">
				<xsl:text>elementID:</xsl:text><xsl:value-of select="$element/@ID"/>
				<xsl:text>,module:'</xsl:text><xsl:value-of select="name($element)"/>
				<xsl:text>',</xsl:text><xsl:value-of select="$params" />
			</xsl:with-param>
			<xsl:with-param name="icon">
				<xsl:text>../system/images/icons/contacts/contacts-18.png</xsl:text>
			</xsl:with-param> 
		</xsl:call-template>
	</xsl:template>
	
	<xsl:template name="groups-permissions">
		<xsl:param name="element"/>
		<xsl:param name="title" select="'Groups'"/>
		<xsl:param name="cssclass"/>
		<xsl:param name="params"/>

		<xsl:call-template name="navigationdetailsitem">
			<xsl:with-param name="title" select="$title"/>
			<xsl:with-param name="panelURI" select="'../../system/tools/security/GroupsPermissions'"/>
			<xsl:with-param name="cssclass" select="$cssclass"/>
			<xsl:with-param name="params">
				<xsl:text>elementID:</xsl:text><xsl:value-of select="$element/@ID"/>
				<xsl:text>,module:'</xsl:text><xsl:value-of select="name($element)"/>
				<xsl:text>',</xsl:text><xsl:value-of select="$params" />
			</xsl:with-param>
			<xsl:with-param name="icon">
				<xsl:text>../system/images/icons/contacts/group-16.png</xsl:text>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	
	<xsl:template name="apply-permissions">
		<xsl:param name="element"/>
		<xsl:param name="title" select="'Apply Permissions'"/>
		<xsl:param name="cssclass"/>
		<xsl:param name="params"/>

		<xsl:call-template name="navigationdetailsitem">
			<xsl:with-param name="title" select="$title"/>
			<xsl:with-param name="panelURI" select="'../../system/tools/security/ApplyPermissions'"/>
			<xsl:with-param name="cssclass" select="$cssclass"/>
			<xsl:with-param name="params">
				<xsl:text>elementID:</xsl:text><xsl:value-of select="$element/@ID"/>
				<xsl:text>,module:'</xsl:text><xsl:value-of select="name($element)"/>
				<xsl:text>',</xsl:text><xsl:value-of select="$params" />
			</xsl:with-param>
			<xsl:with-param name="icon">
				<xsl:text>../system/images/icons/config.png</xsl:text>
			</xsl:with-param> 
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="security-permissions">
		<xsl:param name="element"/>
		<xsl:param name="title" select="'Security'"/>
		<xsl:param name="cssclass"/>
		<xsl:param name="params"/>

		<xsl:param name="tree" select="'false'"/>

		<xsl:call-template name="navigationdetailsitem">
			<xsl:with-param name="title" select="$title"/>
			<xsl:with-param name="panelURI" select="'../../system/tools/security/SecurityActions'"/>
			<xsl:with-param name="cssclass" select="$cssclass"/>
			<xsl:with-param name="params">
				<xsl:text>elementID:</xsl:text><xsl:value-of select="$element/@ID"/>
				<xsl:text>,module:'</xsl:text><xsl:value-of select="name($element)"/>
				<xsl:text>',tree:</xsl:text><xsl:value-of select="$tree"/>
				<xsl:text>,</xsl:text><xsl:value-of select="$params" />
			</xsl:with-param>
			<xsl:with-param name="icon">
				<!--xsl:text>../system/images/icons/config.png</xsl:text-->
			</xsl:with-param> 
		</xsl:call-template>
	</xsl:template>
</xsl:stylesheet>